#include "CVI_Gen.h"

typedef interface tagMCLGen__USB_Gen_Interface MCLGen__USB_Gen_Interface;

typedef struct tagMCLGen__USB_Gen_VTable
{
	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *QueryInterface )( MCLGen__USB_Gen_Interface __RPC_FAR * This, 
	                                                         REFIID riid, 
	                                                         void __RPC_FAR *__RPC_FAR *ppvObject);

	ULONG ( STDMETHODCALLTYPE __RPC_FAR *AddRef )( MCLGen__USB_Gen_Interface __RPC_FAR * This);

	ULONG ( STDMETHODCALLTYPE __RPC_FAR *Release )( MCLGen__USB_Gen_Interface __RPC_FAR * This);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetTypeInfoCount )( MCLGen__USB_Gen_Interface __RPC_FAR * This, 
	                                                           UINT __RPC_FAR *pctinfo);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetTypeInfo )( MCLGen__USB_Gen_Interface __RPC_FAR * This, 
	                                                      UINT iTInfo, 
	                                                      LCID lcid, 
	                                                      ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetIDsOfNames )( MCLGen__USB_Gen_Interface __RPC_FAR * This, 
	                                                        REFIID riid, 
	                                                        LPOLESTR __RPC_FAR *rgszNames, 
	                                                        UINT cNames, 
	                                                        LCID lcid, 
	                                                        DISPID __RPC_FAR *rgDispId);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Invoke )( MCLGen__USB_Gen_Interface __RPC_FAR * This, 
	                                                 DISPID dispIdMember, 
	                                                 REFIID riid, 
	                                                 LCID lcid, 
	                                                 WORD wFlags, 
	                                                 DISPPARAMS __RPC_FAR *pDispParams, 
	                                                 VARIANT __RPC_FAR *pVarResult, 
	                                                 EXCEPINFO __RPC_FAR *pExcepInfo, 
	                                                 UINT __RPC_FAR *puArgErr);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetStatus2_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                     VBOOL *status2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetStatus2_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                     VBOOL status2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Get_Address_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                      short *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Get_Available_Address_List_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                                     BSTR *add_List, 
	                                                                     short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_Address_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                      short address, 
	                                                      unsigned char *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetFirmware_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                      short *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetExtFirmware_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                         unsigned char *a0, 
	                                                         unsigned char *a1, 
	                                                         unsigned char *a2, 
	                                                         unsigned char *a3, 
	                                                         BSTR *docFirmware, 
	                                                         short *arg6);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetGenStatus_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                       unsigned char *locked, 
	                                                       short *powerIsOn, 
	                                                       double *fr, 
	                                                       float *pr, 
	                                                       VARIANT *UNLEVELHigh, 
	                                                       VARIANT *UNLEVELLow, 
	                                                       short *arg7);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetGenMinFreq_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                        float *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetGenMinPower_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                         float *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ExtRefDetected_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                         short *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetGenMaxPower_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                         float *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetGenMaxFreq_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                        float *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetGenStepFreq_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                         float *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_Noise_Spur_Mode_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                              short nsm, 
	                                                              unsigned char *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_Trigger_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                      unsigned char *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_Trigger_As_Input_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                               unsigned char *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Set_Trigger_As_Output_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                                unsigned char *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Clear_Trigger_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                        unsigned char *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Get_Noise_Spur_Mode_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                              short *nsm, 
	                                                              unsigned char *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetPower_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                   float pr, 
	                                                   short triggerOut, 
	                                                   unsigned char *arg3);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ResetCPU_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                   unsigned char *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetPowerON_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                     unsigned char *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetPowerOFF_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                      unsigned char *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetTriggerIn_Status_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                              short *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetFreqAndPower_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                          double fr, 
	                                                          float pr, 
	                                                          short triggerOut, 
	                                                          unsigned char *arg4);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *SetFreq_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                  double fr, 
	                                                  short triggerOut, 
	                                                  unsigned char *arg3);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetDeviceTemperature_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                               float *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Get_Available_SN_List_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                                BSTR *SN_List, 
	                                                                short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *GetStatus_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                    short *arg1);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Read_ModelName_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                         BSTR *modelName, 
	                                                         short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Read_SN_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                  BSTR *SN, 
	                                                  short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Connect_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                  BSTR SN, 
	                                                  short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *ConnectByAddress_) (MCLGen__USB_Gen_Interface __RPC_FAR *This, 
	                                                           short address, 
	                                                           short *arg2);

	HRESULT ( STDMETHODCALLTYPE __RPC_FAR *Disconnect_) (MCLGen__USB_Gen_Interface __RPC_FAR *This);

} MCLGen__USB_Gen_VTable;

typedef interface tagMCLGen__USB_Gen_Interface
{
	CONST_VTBL MCLGen__USB_Gen_VTable __RPC_FAR *lpVtbl;
} MCLGen__USB_Gen_Interface;

const IID MCLGen_IID__USB_Gen =
	{
		0xC7B58F6B, 0x1EAA, 0x47F2, 0x87, 0x17, 0x99, 0xF2, 0x9A, 0xEE, 0x33, 0x6A
	};

HRESULT CVIFUNC MCLGen_New_USB_Gen (const char *server,
                                    int supportMultithreading, LCID locale,
                                    int reserved, CAObjHandle *objectHandle)
{
	HRESULT __result = S_OK;
	GUID clsid = {0x4CD509C3, 0x4C57, 0x4148, 0x83, 0x63, 0xC4, 0x7D, 0xC7,
	              0x56, 0x88, 0x1F};

	__result = CA_CreateObjectByClassIdEx (&clsid, server,
	                                       &MCLGen_IID__USB_Gen,
	                                       supportMultithreading, locale,
	                                       reserved, objectHandle);

	return __result;
}

HRESULT CVIFUNC MCLGen_Open_USB_Gen (const char *fileName, const char *server,
                                     int supportMultithreading, LCID locale,
                                     int reserved, CAObjHandle *objectHandle)
{
	HRESULT __result = S_OK;
	GUID clsid = {0x4CD509C3, 0x4C57, 0x4148, 0x83, 0x63, 0xC4, 0x7D, 0xC7,
	              0x56, 0x88, 0x1F};

	__result = CA_LoadObjectFromFileByClassIdEx (fileName, &clsid, server,
	                                             &MCLGen_IID__USB_Gen,
	                                             supportMultithreading, locale,
	                                             reserved, objectHandle);

	return __result;
}

HRESULT CVIFUNC MCLGen_Active_USB_Gen (const char *server,
                                       int supportMultithreading, LCID locale,
                                       int reserved, CAObjHandle *objectHandle)
{
	HRESULT __result = S_OK;
	GUID clsid = {0x4CD509C3, 0x4C57, 0x4148, 0x83, 0x63, 0xC4, 0x7D, 0xC7,
	              0x56, 0x88, 0x1F};

	__result = CA_GetActiveObjectByClassIdEx (&clsid, server,
	                                          &MCLGen_IID__USB_Gen,
	                                          supportMultithreading, locale,
	                                          reserved, objectHandle);

	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetStatus2 (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, VBOOL *status2)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	VBOOL status2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetStatus2_ (__vtblIFacePtr,
	                                                 &status2__Temp));

	if (status2)
		{
		*status2 = status2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenSetStatus2 (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, VBOOL status2)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetStatus2_ (__vtblIFacePtr, status2));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGet_Address (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, short *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Get_Address_ (__vtblIFacePtr,
	                                                  &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGet_Available_Address_List (CAObjHandle objectHandle,
                                                           ERRORINFO *errorInfo,
                                                           char **add_List,
                                                           short *arg2)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR add_List__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*add_List, &add_List__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Get_Available_Address_List_ (__vtblIFacePtr,
	                                                                 &add_List__AutoType,
	                                                                 &arg2__Temp));

	if (add_List)
		{
		CA_FreeMemory (*add_List);
		*add_List = 0;
		}
	if (add_List)
		__caErrChk (CA_BSTRGetCString (add_List__AutoType, add_List));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (add_List__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (add_List)
			{
			CA_FreeMemory (*add_List);
			*add_List = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenSet_Address (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, short address,
                                            unsigned char *arg2)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_Address_ (__vtblIFacePtr, address,
	                                                  &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetFirmware (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, short *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetFirmware_ (__vtblIFacePtr,
	                                                  &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetExtFirmware (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               unsigned char *a0,
                                               unsigned char *a1,
                                               unsigned char *a2,
                                               unsigned char *a3,
                                               char **docFirmware, short *arg6)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR docFirmware__AutoType = 0;
	short arg6__Temp;

	__caErrChk (CA_CStringToBSTR (*docFirmware, &docFirmware__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetExtFirmware_ (__vtblIFacePtr, a0,
	                                                     a1, a2, a3,
	                                                     &docFirmware__AutoType,
	                                                     &arg6__Temp));

	if (docFirmware)
		{
		CA_FreeMemory (*docFirmware);
		*docFirmware = 0;
		}
	if (docFirmware)
		__caErrChk (CA_BSTRGetCString (docFirmware__AutoType, docFirmware));
	if (arg6)
		{
		*arg6 = arg6__Temp;
		}

Error:
	CA_FreeBSTR (docFirmware__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (docFirmware)
			{
			CA_FreeMemory (*docFirmware);
			*docFirmware = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetGenStatus (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             unsigned char *locked,
                                             short *powerIsOn, double *fr,
                                             float *pr, VARIANT *UNLEVELHigh,
                                             VARIANT *UNLEVELLow, short *arg7)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg7__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetGenStatus_ (__vtblIFacePtr, locked,
	                                                   powerIsOn, fr, pr,
	                                                   UNLEVELHigh, UNLEVELLow,
	                                                   &arg7__Temp));

	if (arg7)
		{
		*arg7 = arg7__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (UNLEVELHigh)
			CA_VariantClear (UNLEVELHigh);
		if (UNLEVELLow)
			CA_VariantClear (UNLEVELLow);
		}
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetGenMinFreq (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo, float *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	float arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetGenMinFreq_ (__vtblIFacePtr,
	                                                    &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetGenMinPower (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo, float *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	float arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetGenMinPower_ (__vtblIFacePtr,
	                                                     &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenExtRefDetected (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo, short *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->ExtRefDetected_ (__vtblIFacePtr,
	                                                     &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetGenMaxPower (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo, float *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	float arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetGenMaxPower_ (__vtblIFacePtr,
	                                                     &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetGenMaxFreq (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo, float *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	float arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetGenMaxFreq_ (__vtblIFacePtr,
	                                                    &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetGenStepFreq (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo, float *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	float arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetGenStepFreq_ (__vtblIFacePtr,
	                                                     &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenSet_Noise_Spur_Mode (CAObjHandle objectHandle,
                                                    ERRORINFO *errorInfo,
                                                    short nsm,
                                                    unsigned char *arg2)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_Noise_Spur_Mode_ (__vtblIFacePtr,
	                                                          nsm, &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenSet_Trigger (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            unsigned char *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_Trigger_ (__vtblIFacePtr,
	                                                  &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenSet_Trigger_As_Input (CAObjHandle objectHandle,
                                                     ERRORINFO *errorInfo,
                                                     unsigned char *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_Trigger_As_Input_ (__vtblIFacePtr,
	                                                           &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenSet_Trigger_As_Output (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      unsigned char *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Set_Trigger_As_Output_ (__vtblIFacePtr,
	                                                            &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenClear_Trigger (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              unsigned char *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Clear_Trigger_ (__vtblIFacePtr,
	                                                    &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGet_Noise_Spur_Mode (CAObjHandle objectHandle,
                                                    ERRORINFO *errorInfo,
                                                    short *nsm,
                                                    unsigned char *arg2)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Get_Noise_Spur_Mode_ (__vtblIFacePtr,
	                                                          nsm, &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenSetPower (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, float pr,
                                         short triggerOut, unsigned char *arg3)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg3__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetPower_ (__vtblIFacePtr, pr,
	                                               triggerOut, &arg3__Temp));

	if (arg3)
		{
		*arg3 = arg3__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenResetCPU (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo,
                                         unsigned char *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->ResetCPU_ (__vtblIFacePtr, &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenSetPowerON (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           unsigned char *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetPowerON_ (__vtblIFacePtr,
	                                                 &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenSetPowerOFF (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            unsigned char *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetPowerOFF_ (__vtblIFacePtr,
	                                                  &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetTriggerIn_Status (CAObjHandle objectHandle,
                                                    ERRORINFO *errorInfo,
                                                    short *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetTriggerIn_Status_ (__vtblIFacePtr,
	                                                          &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenSetFreqAndPower (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo, double fr,
                                                float pr, short triggerOut,
                                                unsigned char *arg4)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg4__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetFreqAndPower_ (__vtblIFacePtr, fr,
	                                                      pr, triggerOut,
	                                                      &arg4__Temp));

	if (arg4)
		{
		*arg4 = arg4__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenSetFreq (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, double fr,
                                        short triggerOut, unsigned char *arg3)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	unsigned char arg3__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->SetFreq_ (__vtblIFacePtr, fr,
	                                              triggerOut, &arg3__Temp));

	if (arg3)
		{
		*arg3 = arg3__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetDeviceTemperature (CAObjHandle objectHandle,
                                                     ERRORINFO *errorInfo,
                                                     float *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	float arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetDeviceTemperature_ (__vtblIFacePtr,
	                                                           &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGet_Available_SN_List (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      char **SN_List,
                                                      short *arg2)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR SN_List__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*SN_List, &SN_List__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Get_Available_SN_List_ (__vtblIFacePtr,
	                                                            &SN_List__AutoType,
	                                                            &arg2__Temp));

	if (SN_List)
		{
		CA_FreeMemory (*SN_List);
		*SN_List = 0;
		}
	if (SN_List)
		__caErrChk (CA_BSTRGetCString (SN_List__AutoType, SN_List));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (SN_List__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (SN_List)
			{
			CA_FreeMemory (*SN_List);
			*SN_List = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenGetStatus (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, short *arg1)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg1__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->GetStatus_ (__vtblIFacePtr,
	                                                &arg1__Temp));

	if (arg1)
		{
		*arg1 = arg1__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenRead_ModelName (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               char **modelName, short *arg2)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR modelName__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*modelName, &modelName__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Read_ModelName_ (__vtblIFacePtr,
	                                                     &modelName__AutoType,
	                                                     &arg2__Temp));

	if (modelName)
		{
		CA_FreeMemory (*modelName);
		*modelName = 0;
		}
	if (modelName)
		__caErrChk (CA_BSTRGetCString (modelName__AutoType, modelName));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (modelName__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (modelName)
			{
			CA_FreeMemory (*modelName);
			*modelName = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenRead_SN (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, char **SN,
                                        short *arg2)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR SN__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (*SN, &SN__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Read_SN_ (__vtblIFacePtr,
	                                              &SN__AutoType, &arg2__Temp));

	if (SN)
		{
		CA_FreeMemory (*SN);
		*SN = 0;
		}
	if (SN)
		__caErrChk (CA_BSTRGetCString (SN__AutoType, SN));
	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (SN__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	if (FAILED(__result))
		{
		if (SN)
			{
			CA_FreeMemory (*SN);
			*SN = 0;
			}
		}
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenConnect (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, const char *SN,
                                        short *arg2)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	BSTR SN__AutoType = 0;
	short arg2__Temp;

	__caErrChk (CA_CStringToBSTR (SN, &SN__AutoType));

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Connect_ (__vtblIFacePtr, SN__AutoType,
	                                              &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	CA_FreeBSTR (SN__AutoType);
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenConnectByAddress (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 short address, short *arg2)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;
	short arg2__Temp;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->ConnectByAddress_ (__vtblIFacePtr,
	                                                       address,
	                                                       &arg2__Temp));

	if (arg2)
		{
		*arg2 = arg2__Temp;
		}

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}

HRESULT CVIFUNC MCLGen__USB_GenDisconnect (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo)
{
	HRESULT __result = S_OK;
	MCLGen__USB_Gen_Interface * __vtblIFacePtr = 0;
	int __didAddRef;
	int __errorInfoPresent = 0;

	__caErrChk (CA_GetInterfaceFromObjHandle (objectHandle,
	                                          &MCLGen_IID__USB_Gen, 0,
	                                          &__vtblIFacePtr, &__didAddRef));
	__caErrChk (__vtblIFacePtr->lpVtbl->Disconnect_ (__vtblIFacePtr));

Error:
	if (__vtblIFacePtr && __didAddRef)
		__vtblIFacePtr->lpVtbl->Release (__vtblIFacePtr);
	CA_FillErrorInfoEx (objectHandle, &MCLGen_IID__USB_Gen, __result,
	                    errorInfo, &__errorInfoPresent);
	if (__errorInfoPresent)
		__result = DISP_E_EXCEPTION;
	return __result;
}
