// GenExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GenExample.h"
#include "GenExampleDlg.h"
#import "C:\WINDOWS\system32\mcl_Gen.dll"





#ifdef _DEBUG
#define new DEBUG_NEW
#endif


using namespace MCL_Gen;


_USB_Gen *MyGen;






// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CGenExampleDlg dialog




CGenExampleDlg::CGenExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGenExampleDlg::IDD, pParent)
	, Freq(0)
	, Power(0)
	, RF_ON(0)
	, RF_OFF(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGenExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, Freq);
	DDX_Text(pDX, IDC_EDIT2, Power);
}

BEGIN_MESSAGE_MAP(CGenExampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CGenExampleDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_RADIO1, &CGenExampleDlg::OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, &CGenExampleDlg::OnBnClickedRadio2)
END_MESSAGE_MAP()


// CGenExampleDlg message handlers

BOOL CGenExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGenExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGenExampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGenExampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CGenExampleDlg::OnBnClickedButton1()
{


	
	

	CString freq1,pwr1;
	double freq;
	float pwr;


	HRESULT hresult;
	CLSID clsid;

	CoInitialize(NULL);	//initialize COM library
	hresult=CLSIDFromProgID(OLESTR("MCL_Gen.USB_Gen"), &clsid); 
	
	
	hresult=CoCreateInstance(clsid,NULL,CLSCTX_INPROC_SERVER,__uuidof(_USB_Gen),(LPVOID *) &MyGen);

	int status = MyGen->Connect("");

	GetDlgItemText(IDC_EDIT1,freq1);
	GetDlgItemText(IDC_EDIT2,pwr1);



	int nSize = freq1.GetLength();
	char *freqCh = new char[nSize+1];
	memset(freqCh,0,nSize+1);
	wcstombs(freqCh, freq1, nSize+1);

	 nSize = pwr1.GetLength();
	char *pwrCh = new char[nSize+1];
	memset(pwrCh,0,nSize+1);
	wcstombs(pwrCh, pwr1, nSize+1);



	freq = atof(freqCh);
	pwr = (float)atof(pwrCh);

	status = MyGen->SetFreqAndPower(freq,pwr,0);


	int ofir = 9;
//	int status = MyGen->SetFreqAndPower(




	// TODO: Add your control notification handler code here
}

void CGenExampleDlg::OnBnClickedRadio1()
{
	int status = MyGen->SetPowerON();
	// TODO: Add your control notification handler code here
}

void CGenExampleDlg::OnBnClickedRadio2()
{
	int status = MyGen->SetPowerOFF();
	// TODO: Add your control notification handler code here
}
