VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4545
   ClientLeft      =   3345
   ClientTop       =   1830
   ClientWidth     =   4110
   LinkTopic       =   "Form1"
   ScaleHeight     =   4545
   ScaleWidth      =   4110
   Begin VB.Frame Frame1 
      Caption         =   "RF Signal"
      Height          =   975
      Left            =   2520
      TabIndex        =   7
      Top             =   1320
      Width           =   1335
      Begin VB.OptionButton RF_OFF 
         Caption         =   "OFF"
         Enabled         =   0   'False
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   600
         Width           =   975
      End
      Begin VB.OptionButton RF_ON 
         Caption         =   "ON"
         Enabled         =   0   'False
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   240
         Width           =   975
      End
   End
   Begin VB.CommandButton ExitButton 
      Caption         =   "Exit"
      Height          =   375
      Left            =   1680
      TabIndex        =   6
      Top             =   2880
      Width           =   735
   End
   Begin VB.CommandButton SetButton 
      Caption         =   "Set"
      Height          =   375
      Left            =   600
      TabIndex        =   5
      Top             =   2880
      Width           =   735
   End
   Begin VB.TextBox Power 
      Height          =   285
      Left            =   1200
      TabIndex        =   4
      Top             =   2160
      Width           =   735
   End
   Begin VB.TextBox Freq 
      Height          =   285
      Left            =   1200
      TabIndex        =   3
      Top             =   1200
      Width           =   735
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "Power:"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   2160
      Width           =   855
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Freq:"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   1200
      Width           =   855
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "MCL Generator Example"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   177
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   3855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim MyGen As New MCL_Gen.USB_Gen
Dim status1 As Integer





Private Sub ExitButton_Click()
    status1 = MyGen.SetPowerOFF
    MyGen.Disconnect
    Unload Me
End Sub




Private Sub Form_Load()

    ' trying to connect the generator
    status1 = MyGen.Connect
    
    ' in case the connection failed
    ' for example if the usb cable not connected
    If status1 = 0 Then
        MsgBox ("Gen Not Connected , please check USB connection")
        Unload Me
    
    End If
    
    
    
    
End Sub
' set the RF signal on
Private Sub RF_OFF_Click()
    status1 = MyGen.SetPowerOFF
End Sub
' set the RF signal off
Private Sub RF_ON_Click()
    status1 = MyGen.SetPowerON
End Sub

' set the generator signal to a specific Freq and Power
Private Sub SetButton_Click()
    Dim status2 As Byte
    
    If Freq.Text = "" Or Power.Text = "" Then
        MsgBox ("Please Insert Freq and Power")
        Exit Sub
    Else
        status2 = MyGen.SetFreqAndPower(CDbl(Freq.Text), CDbl(Power.Text), 0)
        RF_ON.Enabled = True
        RF_OFF.Enabled = True
    End If
End Sub
