unit GenExample;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,MCL_Gen_TLB,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Freq: TEdit;
    Power: TEdit;
    GroupBox1: TGroupBox;
    RF_ON: TRadioButton;
    RF_OFF: TRadioButton;
    SetButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure SetButtonClick(Sender: TObject);
    procedure RF_ONClick(Sender: TObject);
    procedure RF_OFFClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MyGen:USB_Gen;
  status:Integer;
  freq1:WideString;
  pwr1:WideString;
  freq2:Double;
  pwr:Single;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
         MyGen := CoUSB_Gen.Create;
         status:= MyGen.Connect('');
end;

procedure TForm1.SetButtonClick(Sender: TObject);
begin
     freq1:= Freq.Text;
     pwr1:= Power.Text;
      RF_ON.Enabled:= true;
      RF_OFF.Enabled:= true;
      freq2:= StrToFloat(freq1);
      pwr := StrToFloat(pwr1);
      status:=MyGen.SetFreqAndPower(freq2,pwr,0);

end;

procedure TForm1.RF_ONClick(Sender: TObject);
begin
     status:= MyGen.SetPowerON;
end;

procedure TForm1.RF_OFFClick(Sender: TObject);
begin
     status:= MyGen.SetPowerOFF;
end;

end.



